#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/wait.h>
#include <math.h>
#include <string.h>
void printhelp(char* a, char* b);


int calch (int *arr, int n)
{

  int h;
  unsigned int sum = 0;           /* The sum of all elements so far. */
  float average;
  float std_dev;
  unsigned int sum_sqrs = 0;      /* The sum of their squares. */

 int i;

  for (i = 0; i < n; i++)
  {
    sum += arr[i];
  }

  average = (float)sum / (float)n;  //The average of all the sizes

    for (i = 0; i < n; i++)
  {
    sum_sqrs += (arr[i]-average)*(arr[i]-average);
  }
  if(n==1)std_dev=0;
  else  std_dev = sqrt(sum_sqrs/(float)(n-1)); //The standard deviation of the sizes

  h=(int)(3.5*(std_dev)/pow(n,(1./3.))); //Now we can calculate h
  return(h);

}

int main(int argc, char *argv[])
{
    int tam, j, max, min, k, prog;
    int *pent;
    pid_t pid;
    int pfd[2];
    int status;
    FILE * sd;
    /*
     * Create a pipe.
     */
    if (pipe(pfd) < 0) {
        perror("pipe");
        exit(1);
    }

    /*
     * Create a child process.
     */
    if ((pid = fork()) < 0) {
        perror("fork");
        exit(1);
    }

	
    if(argc<2)argv[1]=getenv("HOME");    //If the user didn't used arguments (will look in $HOME)
    if (pid == 0) {
      int junk;
        dup2(pfd[1], 1); //Makes standard output write on the pipe
        close(pfd[0]);  //Close the reading end of the pipe (not used)
        junk = open("/dev/null", O_WRONLY);
        dup2(junk, 2);           //Error messages to junk
        execlp("./script_du.sh", "script_du.sh", argv[1], NULL);
        perror("exec");
        exit(-1);
    }
	
	sd = fdopen(pfd[0], "r");    //Makes standard input read from the pipe
    waitpid(pid, &status, 0);
	fscanf(sd,"%d",&prog);        //Reads output from what_prog.sh
    if(!prog){printf("No tiene ni octave ni matlab, este programa no puede correr y se terminara\n"); exit(1);}
    else if(prog==2)printf("Este programa se graficara usando octave\n");
    else if(prog==1)printf("Este programa se graficara usando matlab\n");
	
	
    fscanf(sd,"%d",&tam);        //Reads how many lines will come from script_du.sh
    if(tam<0)printhelp(argv[1], argv[0]);    //If it doesn't read anything, show HELP and ends
    if((pent=(int*)malloc(sizeof(int)*(tam)))==NULL)exit(1);
    for(j=0;j<(tam);j++){
                         fscanf(sd,"%d",(pent + j));              //stores the size of the files in an array, while calculating min and max sizes
                         if(j==0){max=pent[0];min=pent[0];}       
                         else{
                              if (pent[j]>max)max=pent[j];
                              if (pent[j]<min)min=pent[j];
                         }
    }
    
    //Number of bins
    if(tam>1024)k=(int)(M_LOG2E*log(tam)+1);              //If there are too many files        
    else {
         k=calch(pent, tam);                              //Normal form
         if(k==0 || k==1)k=2;
         else { k=(max-min)/k; if(k==0 || k==1)k=2;}      //If standard deviation is 0 or theres only one bin
    }

   if ((pid = fork()) < 0) {
        perror("fork");
        exit(1);
    }
    
    //Opens matlab or octave
    if (pid == 0) {
        int junk;
        /*
         * Attach standard input of this child process to read from the pipe.
         */
        dup2(pfd[0], 0);   //Makes standard input read from the pipe 
        close(pfd[1]);  /* close the write end of the pipe */
        junk = open("/dev/null", O_WRONLY);
        dup2(junk, 1);  /* throw away any message sent to screen*/
        dup2(junk, 2);  /* throw away any error message */
        if(prog==2)execlp("octave", "octave", "-i", NULL);
        else execlp("matlab", "matlab", "-nodesktop", NULL);
        perror("exec");
        exit(-1);
    }

    sd = fdopen(pfd[1], "w");
    fprintf(sd, "x= [");     
    for ( j= 0; j<tam; j++)
      fprintf(sd, "%d ", pent[j]);      //fills the vector of file sizes
    fprintf(sd, "];\n");
    fprintf(sd, "y= %d;\n", k);         //gives the number of bins
    fprintf(sd, "subplot(2,1,1);\n");
    if(prog==2)fprintf(sd, "hist(x,y,1);\n");	//makes histogram of the data in vector X with Y bins and norm 1
    else {
        fprintf(sd, "[m,xout]=hist(x,y);\n");
        fprintf(sd, "for i = 1 : numel(m)\nm(i)=m(i)/%d;\nend\n", tam);
        fprintf(sd, "bar(xout,m);\n");			//normalizes the graph
        }      
    fprintf(sd,"xlabel('Folder size [KBytes]');\n");
    fprintf(sd,"ylabel('Frequency');\n");
    fprintf(sd,"title('Folder size histogram');\n");
    fprintf(sd, "subplot(2,1,2);\n");
    fprintf(sd, "plot(abs(fft(x)));\n");
    fprintf(sd,"xlabel('Frequency');\n");
    fprintf(sd,"ylabel('Width');\n");
    fprintf(sd,"title('FFT folder size');\n"); fflush(sd);
    printf("Grafica de carpeta %s mostrado con exito\nPresione ENTER para cerrar el programa", argv[1]);
    getchar();     
    fprintf(sd, "\n exit\n"); fflush(sd);
    free(pent);
     /*
     * Wait for the child to exit and
     * close de pipe.
     */
    waitpid(pid, &status, 0);
    fclose(sd);

    /*
     * Exit with a status of 0, indicating that
     * everything went fine.
     */
    exit(0);
}

//HELP function
void printhelp(char* a, char* b){
    printf("La carpeta \"%s\" no existe\nUso: %s <directorio>\nSi la carpeta posee espacios, usar:\n%s \"<directorio>\"\nSi no se ingresa <directorio> se revisara la carpeta home del usuario\n", a, b, b);
    exit(1);
}
